## net.sf.saxon.expr.sort
Class SortedIterator

    java.lang.Object
      net.sf.saxon.expr.sort.SortedIterator

All Implemented Interfaces:
  LastPositionFinder, Sortable, SequenceIterator, LookaheadIterator

Direct Known Subclasses:
  SortedGroupIterator, SortedTupleIterator

    public class SortedIterator

extends Object
implements SequenceIterator, LastPositionFinder, LookaheadIterator, Sortable

Class to do a sorted iteration

Field Summary
`protected SequenceIterator` `base`
`protected AtomicComparer[]` `comparators`
`protected XPathContext` `context`
`protected int` `count`
`protected Object[]` `nodeKeys`
`protected int` `position`
`protected int` `recordSize`
`protected SortKeyEvaluator` `sortKeyEvaluator`

Fields inherited from interface net.sf.saxon.om.SequenceIterator
`GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

Constructor Summary
`SortedIterator(XPathContext context, SequenceIterator base, SortKeyEvaluator sortKeyEvaluator, AtomicComparer[] comparators)` Create a sorted iterator

Method Summary
`protected void` `buildArray()` Create an array holding the items to be sorted and the values of their sort keys
`void` `close()` Close the iterator.
`int` `compare(int a, int b)` Compare two items in sorted sequence (needed to implement the Sortable interface)
`Item` `current()` Get the current value in the sequence (the one returned by the most recent call on next()).
`SequenceIterator` `getAnother()` Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.
`int` `getLastPosition()` Get the last position (that is, the number of items in the sequence).
`int` `getProperties()` Get properties of this iterator, as a bit-significant integer.
`boolean` `hasNext()` Determine whether there are more items to come.
`Item` `next()` Get the next item, in sorted order
`int` `position()` Get the current position.
`void` `setHostLanguage(int language)` Set the host language
`void` `swap(int a, int b)` Swap two items (needed to implement the Sortable interface)

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### base

    protected SequenceIterator base

### sortKeyEvaluator

    protected SortKeyEvaluator sortKeyEvaluator

### comparators

    protected AtomicComparer[] comparators

### recordSize

    protected int recordSize

### nodeKeys

    protected Object[] nodeKeys

### count

    protected int count

### position

    protected int position

### context

    protected XPathContext context

Constructor Detail

### SortedIterator

    public SortedIterator(XPathContext context,
                          SequenceIterator base,
                          SortKeyEvaluator sortKeyEvaluator,
                          AtomicComparer[] comparators)

  Create a sorted iterator

  Parameters:
    `context` - the dynamic XPath evaluation context
    `base` - an iterator over the sequence to be sorted
    `sortKeyEvaluator` - an object that allows the n'th sort key for a given item to be evaluated
    `comparators` - an array of AtomicComparers, one for each sort key, for comparing sort key values

Method Detail

### setHostLanguage

    public void setHostLanguage(int language)

  Set the host language

  Parameters:
    `language` - the host language (for example `Configuration.XQUERY`)

### hasNext

    public boolean hasNext()

  Determine whether there are more items to come. Note that this operation is stateless and it is not necessary (or usual) to call it before calling next(). It is used only when there is an explicit need to tell if we are at the last element.

  This method must not be called unless the result of getProperties() on the iterator includes the bit setting `SequenceIterator.LOOKAHEAD`

  Specified by:
    `hasNext` in interface `LookaheadIterator`
  Returns:
    true if there are more items in the sequence

### next

    public Item next()
              throws XPathException

  Get the next item, in sorted order

  Specified by:
    `next` in interface `SequenceIterator`
  Returns:
    the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.
  Throws:
    `XPathException` - if an error occurs retrieving the next item

### current

    public Item current()

  Description copied from interface: `SequenceIterator`
  Get the current value in the sequence (the one returned by the most recent call on next()). This will be null before the first call of next(). This method does not change the state of the iterator.

  Specified by:
    `current` in interface `SequenceIterator`
  Returns:
    the current item, the one most recently returned by a call on next(). Returns null if next() has not been called, or if the end of the sequence has been reached.

### position

    public int position()

  Description copied from interface: `SequenceIterator`
  Get the current position. This will usually be zero before the first call on next(), otherwise it will be the number of times that next() has been called. Once next() has returned null, the preferred action is for subsequent calls on position() to return -1, but not all existing implementations follow this practice. (In particular, the EmptyIterator is stateless, and always returns 0 as the value of position(), whether or not next() has been called.)

  This method does not change the state of the iterator.

  Specified by:
    `position` in interface `SequenceIterator`
  Returns:
    the current position, the position of the item returned by the most recent call of next(). This is 1 after next() has been successfully called once, 2 after it has been called twice, and so on. If next() has never been called, the method returns zero. If the end of the sequence has been reached, the value returned will always be <= 0; the preferred value is -1.

### getLastPosition

    public int getLastPosition()
                        throws XPathException

  Description copied from interface: `LastPositionFinder`
  Get the last position (that is, the number of items in the sequence). This method is non-destructive: it does not change the state of the iterator. The result is undefined if the next() method of the iterator has already returned null. This method must not be called unless the result of getProperties() on the iterator includes the bit setting `SequenceIterator.LAST_POSITION_FINDER`

  Specified by:
    `getLastPosition` in interface `LastPositionFinder`
  Throws:
    `XPathException`

### close

    public void close()

  Description copied from interface: `SequenceIterator`
  Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

  (Currently, closing an iterator is important only when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.)

  Specified by:
    `close` in interface `SequenceIterator`

### getAnother

    public SequenceIterator getAnother()
                                throws XPathException

  Description copied from interface: `SequenceIterator`
  Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.

  This method allows access to all the items in the sequence without disturbing the current position of the iterator. Internally, its main use is in evaluating the last() function.

  This method does not change the state of the iterator.

  Specified by:
    `getAnother` in interface `SequenceIterator`
  Returns:
    a SequenceIterator that iterates over the same items, positioned before the first item
  Throws:
    `XPathException` - if any error occurs

### getProperties

    public int getProperties()

  Get properties of this iterator, as a bit-significant integer.

  Specified by:
    `getProperties` in interface `SequenceIterator`
  Returns:
    the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED`, `SequenceIterator.LAST_POSITION_FINDER`, and `SequenceIterator.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

### buildArray

    protected void buildArray()
                       throws XPathException

  Create an array holding the items to be sorted and the values of their sort keys

  Throws:
    `XPathException`

### compare

    public int compare(int a,
                       int b)

  Compare two items in sorted sequence (needed to implement the Sortable interface)

  Specified by:
    `compare` in interface `Sortable`
  Returns:
    <0 if obj[a]<obj[b], 0 if obj[a]=obj[b], >0 if obj[a]>obj[b]

### swap

    public void swap(int a,
                     int b)

  Swap two items (needed to implement the Sortable interface)

  Specified by:
    `swap` in interface `Sortable`

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.